var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
import * as util from 'redux-service-util';
import * as service from '../todos-service';
jest.mock('../../config', function () { return ({
    config: { apiBasePath: 'http://someapipath' },
}); });
jest.mock('redux-service-util', function () { return ({
    doDelete: jest.fn(),
    doPatch: jest.fn(),
    doFetch: jest.fn(),
    doPost: jest.fn(),
}); });
function createTodo(id, completed) {
    if (id === void 0) { id = 'abc123'; }
    if (completed === void 0) { completed = false; }
    return {
        id: id,
        completed: completed,
        title: "a testing todo: " + id,
    };
}
var doFetchMock = util.doFetch;
var doDeleteMock = util.doDelete;
var doPostMock = util.doPost;
var doPatchMock = util.doPatch;
beforeEach(function () {
    doPatchMock.mockReset();
    doFetchMock.mockReset();
    doPostMock.mockReset();
    doPatchMock.mockReset();
});
describe('the todosList service function', function () {
    test('todosList: invokes doFetch with the correct api path', function () {
        service.todosList().catch(function () { });
        expect(doFetchMock.mock.calls[0][0]).toBe('http://someapipath/todos');
    });
    test('todosList: ok api response, todo data mapped', function () { return __awaiter(_this, void 0, void 0, function () {
        var data, result, expected;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    data = [createTodo('1_'), createTodo('2_')];
                    doFetchMock.mockReturnValue(Promise.resolve({ data: data, ok: true }));
                    return [4 /*yield*/, service.todosList().catch(function () { })];
                case 1:
                    result = _a.sent();
                    expected = { '1_': data[0], '2_': data[1] };
                    expect(result.payload).toEqual(expected);
                    expect(result.ok).toBe(true);
                    return [2 /*return*/];
            }
        });
    }); });
    test('todosList: fail api response, error data mapped', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    doFetchMock.mockReturnValue(Promise.resolve({ undefined: undefined, ok: false, status: 401 }));
                    return [4 /*yield*/, service.todosList().catch(function () { })];
                case 1:
                    result = _a.sent();
                    expect(result.payload).toEqual({ status: 401 });
                    expect(result.ok).toBe(false);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('the todoAdd service function', function () {
    test('todoAdd: invokes doPost with the correct api path', function () {
        var todo = createTodo('123abc');
        service.todoAdd(todo).catch(function () { });
        expect(doPostMock.mock.calls[0][0]).toBe('http://someapipath/todos');
    });
    test('todoAdd: ok api response, todo new data mapped to payload', function () { return __awaiter(_this, void 0, void 0, function () {
        var todo, result, expected;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    todo = createTodo('123abc');
                    doPostMock.mockReturnValue(Promise.resolve({ ok: true, data: __assign({}, todo) }));
                    return [4 /*yield*/, service.todoAdd(todo).catch(function () { })];
                case 1:
                    result = _a.sent();
                    expected = { '123abc': todo };
                    expect(result.payload).toEqual(expected);
                    expect(result.ok).toBe(true);
                    return [2 /*return*/];
            }
        });
    }); });
    test('todoAdd: fail api response, error data mapped', function () { return __awaiter(_this, void 0, void 0, function () {
        var todo, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    todo = createTodo('123abc');
                    doPostMock.mockReturnValue(Promise.resolve({ data: undefined, status: 401, ok: false }));
                    return [4 /*yield*/, service.todoAdd(todo).catch(function () { })];
                case 1:
                    result = _a.sent();
                    expect(result.payload).toEqual({ status: 401 });
                    expect(result.ok).toBe(false);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('the todoDelete service function', function () {
    test('todoDelete: invokes doDelete with the correct api path', function () {
        service.todoDelete('123abc').catch(function () { });
        expect(doDeleteMock.mock.calls[0][0]).toBe('http://someapipath/todos/123abc');
    });
    test('todoDelete: ok api response, payload return with deleted id', function () { return __awaiter(_this, void 0, void 0, function () {
        var result, expected;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    doDeleteMock.mockReturnValue(Promise.resolve({ ok: true, data: {} }));
                    return [4 /*yield*/, service.todoDelete('abc123').catch(function () { })];
                case 1:
                    result = _a.sent();
                    expected = { id: 'abc123' };
                    expect(result.payload).toEqual(expected);
                    expect(result.ok).toBe(true);
                    return [2 /*return*/];
            }
        });
    }); });
    test('todoDelete: fail api response, error data mapped', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    doDeleteMock.mockReturnValue(Promise.resolve({ payload: undefined, ok: false, status: 500 }));
                    return [4 /*yield*/, service.todoDelete('abc123').catch(function () { })];
                case 1:
                    result = _a.sent();
                    expect(result.payload).toEqual({ status: 500 });
                    expect(result.ok).toBe(false);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('the todoComplete service function', function () {
    test('todoComplete: invokes doPatch with the correct api path', function () {
        var todo = createTodo('123abc');
        service.todoComplete(todo).catch(function () { });
        expect(doPatchMock.mock.calls[0][0]).toBe('http://someapipath/todos/123abc');
    });
    test('todoComplete: updates the completed flag for the todo to be true', function () {
        var todo = createTodo('123abc');
        service.todoComplete(todo).catch(function () { });
        var completedTodo = __assign({}, todo, { completed: true });
        expect(doPatchMock.mock.calls[0][1]).toEqual(JSON.stringify(completedTodo));
    });
    test('todoComplete: ok api response, payload return with deleted id', function () { return __awaiter(_this, void 0, void 0, function () {
        var todo, result, expected;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    todo = createTodo('123abc');
                    doPatchMock.mockReturnValue(Promise.resolve({ ok: true, data: todo }));
                    return [4 /*yield*/, service.todoComplete(todo).catch(function () { })];
                case 1:
                    result = _a.sent();
                    expected = { '123abc': todo };
                    expect(result.payload).toEqual(expected);
                    expect(result.ok).toBe(true);
                    return [2 /*return*/];
            }
        });
    }); });
    test('todoComplete: fail api response, error data mapped', function () { return __awaiter(_this, void 0, void 0, function () {
        var todo, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    todo = createTodo('123abc');
                    doPatchMock.mockReturnValue(Promise.resolve({ payload: undefined, ok: false, status: 404 }));
                    return [4 /*yield*/, service.todoComplete(todo).catch(function () { })];
                case 1:
                    result = _a.sent();
                    expect(result.payload).toEqual({ status: 404 });
                    expect(result.ok).toBe(false);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('the todoIncomplete service function', function () {
    test('todoIncomplete: invokes doPatch with the correct api path', function () {
        var todo = createTodo('123abc');
        service.todoIncomplete(todo).catch(function () { });
        expect(doPatchMock.mock.calls[0][0]).toBe('http://someapipath/todos/123abc');
    });
    test('todoIncomplete: updates the completed flag for the todo to be false', function () {
        var todo = createTodo('123abcd', true);
        service.todoIncomplete(todo).catch(function () { });
        var incompleteTodo = __assign({}, todo, { completed: false });
        expect(doPatchMock.mock.calls[0][1]).toEqual(JSON.stringify(incompleteTodo));
    });
    test('todoIncomplete: ok api response, payload return with deleted id', function () { return __awaiter(_this, void 0, void 0, function () {
        var todo, result, expected;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    todo = createTodo('123abc');
                    doPatchMock.mockReturnValue(Promise.resolve({ ok: true, data: todo }));
                    return [4 /*yield*/, service.todoIncomplete(todo).catch(function () { })];
                case 1:
                    result = _a.sent();
                    expected = { '123abc': todo };
                    expect(result.payload).toEqual(expected);
                    expect(result.ok).toBe(true);
                    return [2 /*return*/];
            }
        });
    }); });
    test('todoIncomplete: ok api response but response invalid', function () { return __awaiter(_this, void 0, void 0, function () {
        var todo, result, expected;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    todo = createTodo('123abc');
                    doPatchMock.mockReturnValue(Promise.resolve({ ok: true, data: undefined }));
                    return [4 /*yield*/, service.todoIncomplete(todo).catch(function () { })];
                case 1:
                    result = _a.sent();
                    expected = {};
                    expect(result.payload).toEqual(expected);
                    expect(result.ok).toBe(true);
                    return [2 /*return*/];
            }
        });
    }); });
    test('todoIncomplete: fail api response, error data mapped', function () { return __awaiter(_this, void 0, void 0, function () {
        var todo, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    todo = createTodo('123abc');
                    doPatchMock.mockReturnValue(Promise.resolve({ payload: undefined, ok: false, status: 401 }));
                    return [4 /*yield*/, service.todoIncomplete(todo).catch(function () { })];
                case 1:
                    result = _a.sent();
                    expect(result.payload).toEqual({ status: 401 });
                    expect(result.ok).toBe(false);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=todos-service.test.js.map