var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var _a;
import { actionAsync, INITIAL_ASYNC_STATE, createReducer, reducerAsyncActions, typeOK, apiOnly, withoutApi, asValues, apiStateOK, } from 'redux-service-util';
import * as service from './todos-service';
export var INITIAL_STATE = INITIAL_ASYNC_STATE;
export var types;
(function (types) {
    types["todosList"] = "todosList";
    types["todoAdd"] = "todoAdd";
    types["todoDelete"] = "todoDelete";
    types["todoComplete"] = "todoComplete";
    types["todoIncomplete"] = "todoIncomplete";
})(types || (types = {}));
// action creators
var todosListOptions = {
    type: types.todosList,
    fetched: true,
    handler: service.todosList,
};
var todosList = function () { return actionAsync(todosListOptions); };
var todoAddOptions = {
    type: types.todoAdd,
    updating: 'new',
    handler: service.todoAdd,
};
var todoAdd = function (todo) { return actionAsync(todoAddOptions, todo); };
var todoDeleteOptions = function (todoId) { return ({
    type: types.todoDelete,
    updating: todoId,
    handler: service.todoDelete,
}); };
var todoDelete = function (todoId) { return actionAsync(todoDeleteOptions(todoId), todoId); };
var todoCompleteOptions = function (todo) { return ({
    type: types.todoComplete,
    updating: todo.id,
    handler: service.todoComplete,
}); };
var todoComplete = function (todo) { return actionAsync(todoCompleteOptions(todo), todo); };
var todoIncompleteOptions = function (todo) { return ({
    type: types.todoIncomplete,
    updating: todo.id,
    handler: service.todoIncomplete,
}); };
var todoIncomplete = function (todo) { return actionAsync(todoIncompleteOptions(todo), todo); };
export var actions = {
    todosList: todosList,
    todoAdd: todoAdd,
    todoDelete: todoDelete,
    todoComplete: todoComplete,
    todoIncomplete: todoIncomplete,
};
export var todoDeleteOK = function (state, action) {
    var id = action.payload.id;
    var _a = state, _b = id.toString(), value = _a[_b], withoutDeleted = __rest(_a, [typeof _b === "symbol" ? _b : _b + ""]);
    var api = state.api;
    return __assign({}, withoutDeleted, { api: apiStateOK(api) });
};
// standard async actions, handled via bb-js-data-service-util helpers
var asyncActions = [
    types.todosList,
    types.todoAdd,
    types.todoDelete,
    types.todoComplete,
    types.todoIncomplete,
];
export var reducerMap = __assign({}, reducerAsyncActions(asyncActions, (_a = {}, _a[typeOK(types.todoDelete)] = function (state, action) { return todoDeleteOK(state, action); }, _a)));
export var reducer = createReducer(INITIAL_STATE, reducerMap);
// selectors
var allTodos = function (state) { return withoutApi(state.todos); };
var allTodosAsArray = function (state) { return asValues(state.todos); };
var apiState = function (state) { return apiOnly(state.todos); };
export var select = { allTodos: allTodos, allTodosAsArray: allTodosAsArray, apiState: apiState };
//# sourceMappingURL=todos-state.js.map